static void my_request( struct request_queue *q ) {
   struct request *req;
   char *ptr;
   unsigned nr_sectors, sector;
   DBG( "entering request routine\n" );
   req = blk_fetch_request( q );
   while( req ) {
      int size, res = 0;
      if( !blk_fs_request( req ) ) {
         ERR( "this was not a normal fs request, skipping\n" );
         blk_end_request_cur( req, 0 );
         continue;
//         goto done;
      }
      nr_sectors = blk_rq_cur_sectors( req );
      sector = blk_rq_pos( req );
      ptr = my_dev + sector * KERNEL_SECTOR_SIZE;
      size = nr_sectors * KERNEL_SECTOR_SIZE;
      if( ( ptr + size ) > ( my_dev + disk_size ) ) {
         ERR( "tried to go past end of device\n" );
         blk_end_request_cur( req, 0 );
         continue;
//         goto done;
      }
      if( rq_data_dir( req ) ) {
         LOG( "writing at sector %d, %u sectors \n", sector, nr_sectors );
         memcpy( ptr, req->buffer, size );
      } else {
         LOG( "reading at sector %d, %u sectors \n", sector, nr_sectors );
         memcpy( req->buffer, ptr, size );
      }
      blk_end_request_cur( req, 1 );
/*      res = 1;
done:
      if( !__blk_end_request_cur( rq, res ) )
         rq = blk_fetch_request( q );
*/
   }
   DBG( "leaving request\n" );
}

